;PCPLUS 2 script to log on to GEnie, alternate provisions for normal half-
;duplex or full-duplex, as you decide.  Insert your own GEnie numbers at
;555-1212 and at the XPC999 etc. in the script below.
;For operation on a typical E71 circuit. Please read comments for further.
;Be sure your Dialing Directory entry for GEnie is set to ANSI, E71, and
;either Half Duplex or Full Duplex to match what you use in this script.
;
;
PROC MAIN                           ;label of main procedure
  SET ATIME 1                       ;set alarm time 1 second
  SET DISPLAY ON                    ;turn on display of line characters
  IF NOT FROMDDIR                   ;if not linked to dialing directory
    EMULATE ANSI                    ;set emulation
    ASSIGN S0 "555-1212"            ;GEnie 2400 baud # for use by MDIAL later
    SET DUPLEX HALF                 ;set half duplex mode OR next line
 ;  SET DUPLEX FULL                 ;set full duplex mode OR previous line
    SET DATABITS 7                  ;set databits 7
    SET PARITY EVEN                 ;set parity even
    SET STOPBITS 1                  ;set stopbits 1
    MDIAL S0 "GEnie (half-duplex)"  ;dial string S0 OR next line
;   MDIAL S0 "GEnie (full-duplex)"  ;dial string S0 OR previous line
    IF NOT CONNECTED                ;if not connected
      HANGUP                        ;hangup
      CALL MAIN                     ;and start over
    ENDIF                           ;end the if not connected
  ENDIF                             ;end the if not from dialing directory
  PAUSE 1                           ;pause to be sure of carrier
  TRANSMIT "H"                      ;wakeup GENIE - no Enter
  WAITFOR "U#="                     ;wait for prompt
  RFLUSH                            ;flush the buffer
; TRANSMIT "^R"                     ;transmit ONLY if full duplex, no cr
  TRANSMIT "XPC99999,XXXX9999^M"    ;send your ID and password
  WAITFOR "to continue?" 45         ;wait for prompt 45 seconds
  IF NOT WAITFOR                    ;if we didn't get in
    HANGUP                          ;hangup
    IF FROMDDIR                     ;if calling from dialing directory
      EXIT                          ;exit script
    ENDIF                           ;end the if
    CALL MAIN                       ;and start over
  ENDIF                             ;end the if case
  ALARM                             ;make some noise
  EXIT                              ;exit script
ENDPROC                             ;end the proc main
;end of script
